<ToolboxBitmap(GetType(TwinkleLabel), "tbxTwinkleLabel.bmp")> _
Public Class TwinkleLabel
    Inherits System.Windows.Forms.Label

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        ' This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Control overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Control Designer
    Private components As System.ComponentModel.IContainer

    ' NOTE: The following procedure is required by the Component Designer
    ' It can be modified using the Component Designer.  Do not modify it
    ' using the code editor.
    Friend WithEvents tmrTwinkle As System.Windows.Forms.Timer
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.tmrTwinkle = New System.Windows.Forms.Timer(Me.components)
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        '
        'tmrTwinkle
        '
        Me.tmrTwinkle.Enabled = True
        Me.tmrTwinkle.Interval = 500
        '
        'TwinkleLabel
        '

    End Sub

#End Region

    Private m_TwinkleColor As Color = Color.Blue
    Private m_TimeBetweenTwinkles As Integer = 1000
    Private m_TimeBetweenLetters As Integer = 50
    Private m_HighlightedLetter As Integer = 0

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        ' Don't let the control paint normally.
        'MyBase.OnPaint(pe)

        'Add your custom paint code here
        ' Paint each letter individually.
        Dim normal_brush As Brush = New SolidBrush(Me.ForeColor)
        Dim highlight_brush As Brush = New SolidBrush(m_TwinkleColor)
        Dim ch As String
        Dim ch_size As SizeF
        Dim X As Single = 0

        For i As Integer = 0 To Me.Text.Length - 1
            ' Draw the next character.
            ch = Me.Text.Substring(i, 1)
            If i = m_HighlightedLetter Then
                pe.Graphics.DrawString(ch, Me.Font, _
                    highlight_brush, X, 0)
            Else
                pe.Graphics.DrawString(ch, Me.Font, _
                    normal_brush, X, 0)
            End If

            ' Move to the next character's position.
            ch_size = _
                pe.Graphics.MeasureString( _
                    ch, _
                    Me.Font, _
                    New PointF(X, 0), _
                    System.Drawing.StringFormat.GenericTypographic)
            X += ch_size.Width
        Next i

        ' Move to the next character.
        m_HighlightedLetter += 1
        If m_HighlightedLetter = 0 Then
            ' Pause before highlighting the first character.
            tmrTwinkle.Interval = m_TimeBetweenTwinkles
        ElseIf m_HighlightedLetter >= Me.Text.Length Then
            ' Start over.
            m_HighlightedLetter = -1
            tmrTwinkle.Interval = m_TimeBetweenLetters
        Else
            ' Move to the next character as usual.
            tmrTwinkle.Interval = m_TimeBetweenLetters
        End If
    End Sub

    Public Property TwinkleColor() As Color
        Get
            Return m_TwinkleColor
        End Get
        Set(ByVal Value As Color)
            m_TwinkleColor = Value
        End Set
    End Property

    Public Property TimeBetweenTwinkles() As Integer
        Get
            Return m_TimeBetweenTwinkles
        End Get
        Set(ByVal Value As Integer)
            m_TimeBetweenTwinkles = Value
        End Set
    End Property

    Public Property TimeBetweenLetters() As Integer
        Get
            Return m_TimeBetweenLetters
        End Get
        Set(ByVal Value As Integer)
            m_TimeBetweenLetters = Value
        End Set
    End Property

    Private Shadows Property Enabled() As Boolean
        Get
            Return MyBase.Enabled
        End Get
        Set(ByVal Value As Boolean)
            MyBase.Enabled = Value

            Me.tmrTwinkle.Enabled = MyBase.Enabled
        End Set
    End Property

    Private Sub tmrTwinkle_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrTwinkle.Tick
        Invalidate()
    End Sub

    ' The text is changing.
    Public Overrides Property Text() As String
        Get
            Return MyBase.Text
        End Get
        Set(ByVal Value As String)
            m_HighlightedLetter = 0
            MyBase.Text = Value
            MyBase.Invalidate()
        End Set
    End Property
End Class
