<ToolboxBitmap(GetType(HSlider), "tbxHSlider.bmp")> _
Public Class HSlider
    Inherits System.Windows.Forms.Control

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        ' This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Control overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Control Designer
    Private components As System.ComponentModel.IContainer

    ' NOTE: The following procedure is required by the Component Designer
    ' It can be modified using the Component Designer.  Do not modify it
    ' using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

#End Region

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(pe)

        'Add your custom paint code here
        Dim slider_rect As Rectangle
        slider_rect = Me.ClientRectangle
        slider_rect.Width = CType( _
            Me.ClientRectangle.Width * _
                (m_Value - m_Minimum) / (m_Maximum - m_Minimum), _
            Integer)
        pe.Graphics.FillRectangle(New SolidBrush(Me.FillColor), slider_rect)

        slider_rect.Width = Me.ClientRectangle.Width - 1
        slider_rect.Height -= 1
        Dim wide_pen As New Pen(Me.ForeColor, 5)
        pe.Graphics.DrawRectangle(wide_pen, slider_rect)
    End Sub

    Public Event ValueChanged()

    Private m_Value As Integer = 66
    Private m_Minimum As Integer = 0
    Private m_Maximum As Integer = 100
    Private m_FillColor As Color = Color.Green

    Private m_Dragging As Boolean

    Public Property Value() As Integer
        Get
            Return m_Value
        End Get
        Set(ByVal Value As Integer)
            m_Value = Value
            Invalidate()
            RaiseEvent ValueChanged()
        End Set
    End Property

    Public Property Minimum() As Integer
        Get
            Return m_Minimum
        End Get
        Set(ByVal Minimum As Integer)
            m_Minimum = Minimum
        End Set
    End Property

    Public Property Maximum() As Integer
        Get
            Return m_Maximum
        End Get
        Set(ByVal Maximum As Integer)
            m_Maximum = Maximum
        End Set
    End Property

    Public Property FillColor() As Color
        Get
            Return m_FillColor
        End Get
        Set(ByVal FillColor As Color)
            m_FillColor = FillColor
        End Set
    End Property

    Private Sub SetValue(ByVal X As Integer)
        Dim new_value As Integer = CType( _
            m_Minimum + (m_Maximum - m_Minimum) * X / Me.ClientRectangle.Width, _
            Integer)
        If new_value < m_Minimum Then new_value = m_Minimum
        If new_value > m_Maximum Then new_value = m_Maximum
        If new_value <> m_Value Then Value = new_value
    End Sub

    Private Sub HSlider_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        m_Dragging = True
        SetValue(e.X)
    End Sub

    Private Sub HSlider_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        If Not m_Dragging Then Exit Sub
        SetValue(e.X)
    End Sub

    Private Sub HSlider_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        m_Dragging = False
    End Sub
End Class
