Imports System.ComponentModel

<ProvideProperty("CaptionText", GetType(Control))> _
Public Class CaptionSetter
    Inherits System.ComponentModel.Component
    Implements IExtenderProvider

    Private m_ClientCaptions As Hashtable
    Private m_ActiveControl As Control

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

        m_ClientCaptions = New Hashtable
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

#End Region

    Public Function CanExtend(ByVal client_control As Object) As Boolean _
     Implements IExtenderProvider.CanExtend
        Return (TypeOf client_control Is Control)
    End Function

    <ExtenderProvidedProperty(), _
     DefaultValue("")> _
    Public Function GetCaptionText(ByVal client_control As Control) As String
        Dim client_caption As String = CStr(m_ClientCaptions(client_control))
        If client_caption Is Nothing Then Return String.Empty
        Return client_caption
    End Function

    Public Sub SetCaptionText(ByVal client_control As Control, Optional ByVal client_caption As String = "")
        If client_caption.Length = 0 Then
            m_ClientCaptions.Remove(client_control)
            RemoveHandler client_control.Enter, AddressOf OnControlEnter
            RemoveHandler client_control.Leave, AddressOf OnControlLeave
        Else
            m_ClientCaptions(client_control) = client_caption
            AddHandler client_control.Enter, AddressOf OnControlEnter
            AddHandler client_control.Leave, AddressOf OnControlLeave
        End If

        If client_control Is m_ActiveControl Then
            SetCaption()
        End If
    End Sub

    Private Sub OnControlEnter(ByVal sender As Object, ByVal e As EventArgs)
        m_ActiveControl = CType(sender, Control)
        SetCaption()
    End Sub

    Private Sub OnControlLeave(ByVal sender As Object, ByVal e As EventArgs)
        If sender Is m_ActiveControl Then
            m_ActiveControl = Nothing
            SetCaption()
        End If
    End Sub

    Private Sub SetCaption()
        If Not (m_ActiveControl Is Nothing) Then
            Dim client_caption As String = CStr(m_ClientCaptions(m_ActiveControl))
            If Not (client_caption Is Nothing) And (client_caption.Length > 0) Then
                m_ActiveControl.Parent.Text = client_caption
            End If
        End If
    End Sub

    Public Enum FruitsType
        Apple
        Banana
        Cherry
    End Enum
    Private m_FruitType As FruitsType
    Public Property Fruit() As FruitsType
        Get
            Return m_FruitType
        End Get
        Set(ByVal Value As FruitsType)
            m_FruitType = Value
        End Set
    End Property
End Class
